unit frm_Private;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ComCtrls, ToolWin, ExtCtrls, Contnrs, ImgList, CommCtrl;

const
  WM_ALARM_MSG = WM_USER + 28; //  

type
  TAlarms = array of Boolean;

type
  // ,    ""
  TAlarmer = class(TThread)
  private
    FControl: HWND;
  protected
    procedure Execute; override;
  public
    constructor Create(ControlWin: HWND);
  end;

type
  //   TTabControl,  ""  UpdateTabImages;      protected
  TTabControl = class(ComCtrls.TTabControl)
  private
    FEvenAlarm: Boolean; //  -     
  protected
    //   Alarmer-
    procedure WMAlarmMSG(var Msg: TMessage); message WM_ALARM_MSG;
  public
    Alarm: TAlarms; //    (    )
  end;

type
  TFormPrivate = class(TForm)
    Panel1: TPanel;
    Splitter2: TSplitter;
    PMessage: TPanel;
    Panel8: TPanel;
    ToolBar: TToolBar;
    Separator3: TToolButton;
    PCharCount: TPanel;
    Separator4: TToolButton;
    Panel11: TPanel;
    LUserName: TLabel;
    TabControl1: TTabControl;
    Panel2: TPanel;
    Label1: TLabel;
    LNick: TLabel;
    Panel3: TPanel;
    Label2: TLabel;
    LUserID: TLabel;
    TBCloseChat: TButton;
    MChat: TMemo;
    MMessage: TMemo;
    ImageList1: TImageList;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure TabControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure TabControl1GetImageIndex(Sender: TObject; TabIndex: Integer;
      var ImageIndex: Integer);
    procedure TBCloseChatClick(Sender: TObject);
    procedure ProcDeleteSender(UserID: Integer; BAddTab: Boolean);
    procedure LoadHistory(sFile: string);
  private
    { Private declarations }
    Alarmer: TAlarmer; //  - 
    procedure RefreshAlarmer; //      
    procedure RefreshAlarms; //     Alarm
  public
    { Public declarations }
    procedure ProcAddTab(UserID: Integer; Nick: string);
    procedure PrivateMessageAlarm(UserID: Integer);
    procedure ProcAddSender(UserID: Integer);
  end;

type
  TTabUsers = record
    UserID: Integer;
    Nick: string;
    TempMessage: string;
    Alarm: Boolean;
  end;

var
  FormPrivate: TFormPrivate;
  TabUsers: array of TTabUsers;
  SLSenders: TStringList;

implementation

uses frm_Main;

{$R *.dfm}
//-----------------------------------TAlarmer-----------------------------------
constructor TAlarmer.Create(ControlWin: HWND);
begin
  inherited Create(True);
  FreeOnTerminate := False; //  ,    !
  FControl := ControlWin; //   TTabControl,  "" 
  Resume;
end;

procedure TAlarmer.Execute;
var
  i: Integer;
begin
  while (not Terminated) do
  begin
    for i := 0 to 10 do
    begin
      Sleep(50);
      if Terminated then Break; //     (    ? :-)
    end;
    if Terminated then Break;
    //     ...
    PostMessage(FControl, WM_ALARM_MSG, 1, 0);
  end;
  //     ""
  SendMessage(FControl, WM_ALARM_MSG, 0, 0);

  Terminate;
end;
//------------------------------------------------------------------------------
{procedure TTabControl.WMAlarmMSG(var Msg: TMessage);
var
  i: Integer;
begin
  if (Msg.Msg = WM_ALARM_MSG) and Visible then
  begin
    if (Msg.WParam > 0) then //   
    begin
      FEvenAlarm := not FEvenAlarm;
      UpdateTabImages;
    end
    else
    begin //  
      for i := Low(Alarm) to High(Alarm) do
      begin
        Alarm[i] := False;
      end;

      UpdateTabImages;
    end;
  end;
end;}
procedure TTabControl.WMAlarmMSG(var Msg: TMessage);
var
 i,ind: Integer;
 TCItem: TTCItem; //   uses CommCtrl
begin
  if (Msg.Msg = WM_ALARM_MSG) and Visible then
  begin

    {    -  }
    if (Self.Images = nil) then Exit;

    FEvenAlarm := not FEvenAlarm;

    {      
              Alarm
      }
    if (Msg.WParam = 0) then
    begin
      //!//  
      for i := 0  to Self.Tabs.Count-1 do
        if (TabUsers[i] <> nil) then
          TabUsers[i].Alarm := False;
    end;

    {    }
    for i := 0  to Self.Tabs.Count-1 do
    begin
      {    ,    }
      TCItem.mask := TCIF_IMAGE;
      SendMessage(Handle, TCM_GETITEM, i, Longint(@TCItem));

      {   ,    () }
      ind := GetImageIndex(i);

      {      ,   }
      if (TCItem.iImage <> ind) then
      begin
        TCItem.mask := TCIF_IMAGE;
        TCItem.iImage := ind;
        SendMessage(Handle, TCM_SETITEM, i, Longint(@TCItem));
      end;
    end;
  end;
end;
//------------------------------------------------------------------------------
procedure TFormPrivate.FormDestroy(Sender: TObject);
begin
  FreeAndNil(SLSenders);
end;

procedure TFormPrivate.FormCreate(Sender: TObject);
begin
  SLSenders := TStringList.Create;
end;

procedure TFormPrivate.ProcAddTab(UserID: Integer; Nick: string);
  function UserIDExists(UserID: Integer): Boolean;
  var
    i: Integer;
    B: Boolean;
  begin
    B := False;

    for i := 0 to Length(TabUsers) - 1 do
    begin
      if TabUsers[i].UserID = UserID then
      begin
        B := True;
        Break;
      end
    end;

    Result := B;
  end;

  procedure AddUser(UserID: Integer; Nick: string);
  var
    i: Integer;
  begin
    i := High(TabUsers) + 2;
    SetLength(TabUsers, i);
    TabUsers[i - 1].UserID := UserID;
    TabUsers[i - 1].Nick := Nick;
    TabUsers[i - 1].TempMessage := '';
    TabUsers[i - 1].Alarm := False;
  end;
var
  tbInd: Integer;
  TB: Boolean;
begin
  if UserID = -1 then Exit;
  //    
  tbInd := TabControl1.Tabs.IndexOfObject(TObject(UserID));
  //   
  if tbInd = -1 then
  begin
    //       UserID
    tbInd := TabControl1.Tabs.AddObject(Nick, TObject(UserID));
    //    
    if Length(TabUsers) = 0 then AddUser(UserID, Nick)
    else
    //      
    if not UserIDExists(UserID) then AddUser(UserID, Nick);
    //  
    RefreshAlarmer;
    //  
    RefreshAlarms;
  end;
  //    
  if TabControl1.Tabs.Count > 1 then
  begin
    TB := True;
    TabControl1.OnChanging(Self, TB);
  end;
  //      
  TabControl1.TabIndex := tbInd;
  TabControl1.OnChange(Self);

  Self.WindowState := wsNormal;
  Self.Show;
end;

procedure TFormPrivate.TabControl1Change(Sender: TObject); //     
var
  UserID, i: Integer;
begin
  //     
  UserID := Integer(TabControl1.Tabs.Objects[TabControl1.TabIndex]);
  //   
  for i := 0 to Length(TabUsers) - 1 do
  begin
    if TabUsers[i].UserID = UserID then
    begin
      LNick.Caption := TabUsers[i].Nick;
      LUserID.Caption := IntToStr(UserID);
      MMessage.Text := TabUsers[i].TempMessage;
      LoadHistory(IntToStr(UserID));
      //  ID   SLSenders
      ProcDeleteSender(UserID, False); // Tab   ,   

      Break;
    end;
  end;
end;

procedure TFormPrivate.TabControl1Changing(Sender: TObject;
  var AllowChange: Boolean); //     
var
  UserID, i: Integer;
begin
  //     
  UserID := Integer(TabControl1.Tabs.Objects[TabControl1.TabIndex]);
  //   
  for i := 0 to Length(TabUsers) - 1 do
  begin
    if TabUsers[i].UserID = UserID then
    begin
      TabUsers[i].TempMessage := MMessage.Text;
      Break;
    end;
  end;
end;

procedure TFormPrivate.TabControl1GetImageIndex(Sender: TObject;
  TabIndex: Integer; var ImageIndex: Integer);
var
  Alarms: TAlarms;
  EvenAlarm: Boolean;
begin
  ImageIndex := 0;

  with (Sender as TTabControl) do
  begin
    Alarms := Alarm;
    EvenAlarm := FEvenAlarm;
  end;

  if (TabIndex < Length(Alarms)) and (Alarms[TabIndex]) then  {and (TabIndex in [0..2])}
  begin
    if EvenAlarm then Inc(ImageIndex, 1) else Inc(ImageIndex, 2);
  end;
end;

procedure TFormPrivate.TBCloseChatClick(Sender: TObject);
  procedure ResetAlarmFlag(UserID: Integer);
  var
    i: Integer;
  begin
    for i := 0 to Length(TabUsers) do
    begin
      if TabUsers[i].UserID = UserID then
      begin
        TabUsers[i].Alarm := False;
        Break;
      end;
    end;
  end;
var
  i: Integer;
  TB: Boolean;
begin
  if TabControl1.Tabs.Count > 1 then
  begin
    //  TabIndex  
    i := TabControl1.TabIndex - 1;
    if i < 1 then i := 0;
    //   
    TB := True;
    TabControl1.OnChanging(Self, TB);
    //   
    ResetAlarmFlag(Integer(TabControl1.Tabs.Objects[TabControl1.TabIndex])); //     
    //  
    TabControl1.Tabs.Delete(TabControl1.TabIndex);
    //  
    RefreshAlarmer;
    //  
    RefreshAlarms;
    //   
    TabControl1.TabIndex := i;
    TabControl1.OnChange(Self);
  end
  else
  begin
    //   
    TB := True;
    TabControl1.OnChanging(Self, TB);

    Self.Close;
    //   
    ResetAlarmFlag(Integer(TabControl1.Tabs.Objects[TabControl1.TabIndex])); //     
    //  
    TabControl1.Tabs.Delete(TabControl1.TabIndex);

    if Assigned(Alarmer) then
    begin
      Alarmer.Terminate; //  
      Alarmer.WaitFor; //  !  
      FreeAndNil(Alarmer); //    
    end;
  end;
end;

procedure TFormPrivate.RefreshAlarmer;
begin
  if Assigned(Alarmer) then
  begin
    Alarmer.Terminate; //  
    Alarmer.WaitFor; //  !  
    FreeAndNil(Alarmer); //    
  end;

  Alarmer := nil;

  with TabControl1 do
  begin
    SetLength(Alarm, Tabs.Count);
    //     - False
    if (Tabs.Count > 0) then ZeroMemory(@Alarm[0], Length(Alarm));
  end;

  if not Assigned(Alarmer) then Alarmer := TAlarmer.Create(TabControl1.Handle);
end;

procedure TFormPrivate.RefreshAlarms;
  function FindTabIndex(UserID: Integer): Integer;
  var
    i, tbInd: Integer;
  begin
    tbInd := -1;

    for i := 0 to TabControl1.Tabs.Count - 1 do
    begin
      if Integer(TabControl1.Tabs.Objects[i]) = UserID then
      begin
        tbInd := i;
        Break;
      end;
    end;

    Result := tbInd;
  end;
var
  i: Integer;
begin
  for i := 0 to Length(TabUsers) - 1 do
  begin
    TabControl1.Alarm[FindTabIndex(TabUsers[i].UserID)] := TabUsers[i].Alarm;
  end;
end;

procedure TFormPrivate.PrivateMessageAlarm(UserID: Integer);
  function FindTab(UserID: Integer): Boolean;
  var
    i: Integer;
    B: Boolean;
  begin
    B := False;

    for i := 0 to TabControl1.Tabs.Count - 1 do
    begin
      if Integer(TabControl1.Tabs.Objects[i]) = UserID then
      begin
        B := True;
        Break;
      end;
    end;

    Result := B;
  end;

  procedure SerAlarmFlag(UserID: Integer);
  var
    i: Integer;
  begin
    //    
    if FindTab(UserID) then
    begin
      //       ID   
      for i := 0 to Length(TabUsers) - 1 do
      begin
        if TabUsers[i].UserID = UserID then
        begin
          TabUsers[i].Alarm := True;
          RefreshAlarms;
          Break;
        end;
      end;
    end;
  end;
begin
  //  
  ProcAddSender(UserID);
  SerAlarmFlag(UserID);
end;

procedure TFormPrivate.ProcAddSender(UserID: Integer);
var
  i: Integer;
  B: Boolean;
begin
  Self.Caption := ' ';
  //    ,     
  if SLSenders.Count = 0 then SLSenders.Add(IntToStr(UserID));
  //     
  B := True;

  for i := 0 to SLSenders.Count - 1 do
  begin
    if SLSenders.Strings[i] = IntToStr(UserID) then
    begin
      B := False;
      Break;
    end;
  end;
  //   
  if B then SLSenders.Add(IntToStr(UserID));
end;

procedure TFormPrivate.ProcDeleteSender(UserID: Integer; BAddTab: Boolean);
  function GetNick(UserID: Integer): string;
  var
    i: Integer;
  begin
    for i := 0 to FormMain.LVUsers.Items.Count - 1 do
    begin
      if FormMain.LVUsers.Items[i].SubItems[2] = IntToStr(UserID) then
      begin
        Result := FormMain.LVUsers.Items[i].SubItems[0];
        Break;
      end;
    end;
  end;
var
  i: Integer;
begin
  if BAddTab then ProcAddTab(UserID, GetNick(UserID)); //       -  TabControlChange 
  //  ID 
  for i := 0 to SLSenders.Count - 1 do
  begin
    if SLSenders.Strings[i] = IntToStr(UserID) then
    begin
      SLSenders.Delete(i);
      Break;
    end;
  end;
  //   
  for i := 0 to Length(TabUsers) - 1 do
  begin
    if TabUsers[i].UserID = UserID then
    begin
      TabUsers[i].Alarm := False;
      RefreshAlarms;
      Break;
    end;
  end;

  if SLSenders.Count = 0 then
  begin
    Self.Caption := ' ';
  end;
end;

procedure TFormPrivate.LoadHistory(sFile: string);
var
  SL: TStringList;
begin
  SL := TStringList.Create;
  try
    SL.LoadFromFile(Format('%shistory\%s.txt', [ExtractFilePath(Application.ExeName), sFile]));
  except
  end;

  MChat.Text := SL.Text;

  FreeAndNil(SL);
end;

end.
